************************************************
*-- Scroll Bar Demo
*-- Copyright Blue Cursor, Inc. 1994 - 1995
*-- (612) 470-8999
*-- Internet:  75721,326@Compuserve.com
************************************************

* Scroll bar selection constants
#DEFINE SB_HORZ		0
#DEFINE SB_VERT		1
#DEFINE SB_BOTH		3


* Window Messages
#DEFINE WM_NCHITTEST		132
#DEFINE WM_NCLBUTTONDOWN	161

* WM_NCHITTEST return codes
#DEFINE HTSIZE			4
#DEFINE HTMENU			5
#DEFINE HTHSCROLL		6
#DEFINE HTVSCROLL		7
#DEFINE HTMINBUTTON		8
#DEFINE HTMAXBUTTON		9
#DEFINE HTLEFT			10
#DEFINE HTRIGHT			11
#DEFINE HTTOP			12
#DEFINE HTTOPLEFT		13
#DEFINE HTTOPRIGHT		14
#DEFINE HTBOTTOM		15
#DEFINE HTBOTTOMLEFT	16
#DEFINE HTBOTTOMRIGHT	17
#DEFINE HTBORDER		18

* BOOL values
#DEFINE TRUE  1
#DEFINE FALSE 2


PRIVATE hSBShow, hSBSetPos, hSBGetPos, hSBSetRange, ;
	hSBDefFrame, hWSBWinFox, hSBWinScroll, hSBWinChild, ;
	nSBHRange, nSBVRange

*
* Register Needed Windows API Functions
*
IF !("FOXTOOLS.FLL" $ SET("LIBRARY"))
	SET LIBRARY TO (SYS(2004) + "FOXTOOLS.FLL") ADDITIVE
ENDIF
m.hSBShow = REGFN("ShowScrollBar", "III", "")
m.hSBSetPos = REGFN("SetScrollPos", "IIII", "I")
m.hSBGetPos = REGFN("GetScrollPos", "II", "I")
m.hSBDefFrame = REGFN("DefFrameProc", "IIIIL", "I")
m.hSBSetRange = REGFN("SetScrollRange", "IIIII", "")

*
* Initialize WINDOWS API HWND variables for FoxPro window
* and Main scroll bar window.  The latter value is set in SBSetup
*
m.hWSBWinFox = _WHTOHWND(_WMAINWIND())
m.hSBWinScroll = 0
m.hSBWinChild = 0
m.nSBHRange = 0
m.nSBVRange = 0

DO SBMAIN.SPR	&& Define Main Window
DO SCROLL.SPR	&& Define child window, gets, and performs READ


ON KEY LABEL LEFTMOUSE
ON KEY LABEL PGUP
ON KEY LABEL PGDN
RELEASE WINDOW SBMAIN

****************
FUNCTION SBSETUP
****************
**
** Function is called from within Child Window SCX setup snippet.
**
** This function determines what, if any, scroll bars to initialize
** based on the following criteria:
**	1.	If the Main window is sizeable, Both scroll bars are
**		initialized.  The main window can have either a sizeable
**		border, if the window is sizeable, or no border at all.
**		Do not use a sizeable border when the window was not
**		defined with the GROW attribute, and do not use dialog
**		style borders.
**	2.	If the number of columns in the child window is greater
**		than the number of columns in the main window, the
**		horizontal scroll bar is initialized.
**	3.	If the number of rows in the child window is greater
**		than the number of rows in the main windw, the
**		vertical scroll bar is initialized.
** Activated scroll bars then have their range and position set.
**
**	PARAMETERS:
**		m.cChildWin - Window name of child window
**
PARAMETER cChildWin
PRIVATE nDec

m.nDec = SET("DECIMALS")
SET DECIMALS TO 4


*
* Set window handle variable to Windows API HWND value
*
IF WVISIBLE(m.cChildWin)
	ACTIVATE WINDOW (m.cChildWin) SAME
ELSE
	ACTIVATE WINDOW (m.cChildWin) NOSHOW
ENDIF
m.hSBWinChild = _WGETPORT()
IF WVISIBLE(WPARENT(m.cChildWin))
	ACTIVATE WINDOW (WPARENT(m.cChildWin)) SAME
ELSE
	ACTIVATE WINDOW (WPARENT(m.cChildWin)) NOSHOW
ENDIF
m.hSBWinScroll = _WGETPORT()


*
* Activate needed scroll bars, set range, and set initial position
*
DO CASE
	CASE WBORDER(WPARENT(m.cChildWin))	&& Sizeable Parent
		m.nSBVRange = _WHEIGHTP(m.hSBWinChild)
		m.nSBHRange = _WWIDTHP(m.hSBWinChild)
		= CALLFN(m.hSBSetRange, _WHTOHWND(m.hSBWinScroll), SB_VERT, 0, m.nSBVRange, FALSE)
		= CALLFN(m.hSBSetRange, _WHTOHWND(m.hSBWinScroll), SB_HORZ, 0, m.nSBHRange, FALSE)

	CASE _WHEIGHTP(m.hSBWinChild) > _WHEIGHTP(m.hSBWinScroll) ;
			AND _WWIDTHP(m.hSBWinChild) > _WWIDTHP(m.hSBWinScroll)
		m.nSBVRange = _WHEIGHTP(m.hSBWinChild) - _WHEIGHTP(m.hSBWinScroll) + SYSMETRIC(8) + SYSMETRIC(11)
		m.nSBHRange = _WWIDTHP(m.hSBWinChild) - _WWIDTHP(m.hSBWinScroll)
		= CALLFN(m.hSBSetRange, _WHTOHWND(m.hSBWinScroll), SB_VERT, 0, m.nSBVRange, FALSE)
		= CALLFN(m.hSBSetRange, _WHTOHWND(m.hSBWinScroll), SB_HORZ, 0, m.nSBHRange, FALSE)

	CASE _WHEIGHTP(m.hSBWinChild) > _WHEIGHTP(m.hSBWinScroll)
		m.nSBVRange = _WHEIGHTP(m.hSBWinChild) - _WHEIGHTP(m.hSBWinScroll)
		m.nSBHRange = 0
		= CALLFN(m.hSBSetRange, _WHTOHWND(m.hSBWinScroll), SB_VERT, 0, m.nSBVRange, FALSE)

	CASE _WWIDTHP(m.hSBWinChild) > _WWIDTHP(m.hSBWinScroll)
		m.nSBVRange = 0
		m.nSBHRange = _WWIDTHP(m.hSBWinChild) - _WWIDTHP(m.hSBWinScroll)
		= CALLFN(m.hSBSetRange, _WHTOHWND(m.hSBWinScroll), SB_HORZ, 0, m.nSBHRange , FALSE)

ENDCASE
SET DECIMALS TO (m.nDec)
RETURN

***************
FUNCTION SBACTI
***************
**
** READ ACTIVATE function for child window
**
ON KEY LABEL LEFTMOUSE DO SBMOUSE WITH MROW(""), MCOL("")
ON KEY LABEL PGDN DO SBPAGEDN
ON KEY LABEL PGUP DO SBPAGEUP
RETURN

****************
FUNCTION SBDEACT
****************
**
** READ DEACTIVATE function for child window
**
ON KEY LABEL LEFTMOUSE
ON KEY LABEL PGDN
ON KEY LABEL PGUP
RETURN

****************
FUNCTION SBMOUSE
****************
**
** FUNCTION Called by ON KEY LABEL LEFTMOUSE
**
PARAMETERS nMRow, nMCol
PRIVATE nMPos, nHitTest, nMUpRow, nMUpCol, nSBUpRow, nSBUpCol, ;
	nSBTop, nSBBottom, nSBNewPos, nSBThumbPos, nDec

PUSH KEY CLEAR
m.nDec = SET("DECIMALS")
SET DECIMALS TO 4

*
* Convert nMRow and nMCol from Foxels to Pixels.
* Keep in Mind that the value passed to the parameter
* nMRow is the row of FoxPro's client area.  You must
* add the number of Pixels for the Title and Menu bar
* of FoxPro's main window.
*
m.nMRow = m.nMRow * FONTMETRIC(1,WFONT(1,""), WFONT(2,""), WFONT(3,"")) + SYSMETRIC(9) + SYSMETRIC(20)
m.nMCol = m.nMCol * FONTMETRIC(6,WFONT(1,""), WFONT(2,""), WFONT(3,""))

*
* Convert Mouse Position nMRow and nMCol
* to a 32 - bit lParam value where:
*		xPos = (int) LOWORD(lParam)
*		yPos = (int) HIWORD(lParam)
*
m.nMPos = INT(m.nMRow * 2^16 + m.nMCol)

*
* Send an WM_NCHITTEST message to the Frame Window (m.cWinMain).
* The return value indicates where the mouse was clicked.
* You must also check that mouse click position is withing the
* scroll bar window.  This is because if the window has no
* border, nHitTest will be a scroll bar value when the user
* clicks to the outside the scroll bar window.
*
m.nHitTest = CALLFN(m.hSBDefFrame, _WHTOHWND(m.hSBWinScroll), m.hWSBWinFox, WM_NCHITTEST, 0, m.nMPos)
DO CASE
	CASE m.nHitTest = HTVSCROLL ;
			AND m.nMCol  < _WRIGHTP(m.hSBWinScroll)	&& Hit Vertical Scroll Bar
		*
		* Call DefFrameProc with Parameters to say User
		* clicked Left Mouse Button.  This will cause scroll bar
		* to respond to mouse click
		*
		= CALLFN(m.hSBDefFrame, _WHTOHWND(m.hSBWinScroll), m.hWSBWinFox, WM_NCLBUTTONDOWN, m.nHitTest, m.nMPos)

		*
		* Save mouse position when user let up mouse button
		*
		m.nMUpRow = MROW("")
		m.nMUpCol = MCOL("")
		m.nSBUpRow = MROW(WPARENT(WOUTPUT()))
		m.nSBUpCol = MCOL(WPARENT(WOUTPUT()))

		*
		* Determine where on scroll bar user clicked and take
		* appropriate action
		*
		m.nSBTop = _WTOPP(m.hSBWinScroll) + 2 * SYSMETRIC(9) + SYSMETRIC(20) - IIF(WBORDER(WPARENT(WOUTPUT())),0,SYSMETRIC(4)/2)
		m.nSBBottom = m.nSBTop + _WHEIGHTP(m.hSBWinScroll) + SYSMETRIC(4)
		m.nSBThumbPos = m.nSBTop + SYSMETRIC(6) + SBGETPOS(SB_VERT)/m.nSBVRange * (m.nSBBottom - m.nSBTop - 2 * SYSMETRIC(6) - SYSMETRIC(15))
		DO CASE
			CASE BETWEEN(m.nMRow, m.nSBTop, m.nSBTop+SYSMETRIC(6)) && Up Arrow
				IF SBGETPOS(SB_VERT) > 0
					= SBMOVEWIN(FONTMETRIC(1), 0)
				ENDIF

			CASE BETWEEN(m.nMRow, m.nSBBottom-SYSMETRIC(6), m.nSBBottom) && Down Arrow
				IF SBGETPOS(SB_VERT) < _WHEIGHTP(m.hSBWinChild)
					= SBMOVEWIN(-FONTMETRIC(1), 0)
				ENDIF

			CASE BETWEEN(m.nMRow, m.nSBThumbPos, m.nSBThumbPos + SYSMETRIC(15)) && Thumb
				m.nMUpRow = m.nMUpRow * FONTMETRIC(1,WFONT(1,""), WFONT(2,""), WFONT(3,"")) + SYSMETRIC(9) + SYSMETRIC(20)
				m.nMUpCol = m.nMUpCol * FONTMETRIC(6,WFONT(1,""), WFONT(2,""), WFONT(3,""))
				m.nMPos = INT(m.nMUpRow * 2^16 + m.nMUpCol)
				m.nHitTest = CALLFN(m.hSBDefFrame, _WHTOHWND(m.hSBWinScroll), m.hWSBWinFox, WM_NCHITTEST, 0, m.nMPos)
				IF m.nHitTest = HTVSCROLL ;
						AND m.nMUpCol < _WRIGHTP(m.hSBWinScroll)	&& Still on Scroll Bar
					m.nSBUpRow = m.nSBUpRow * FONTMETRIC(1,WFONT(1,WPARENT(WOUTPUT())), WFONT(2,WPARENT(WOUTPUT())), WFONT(3,WPARENT(WOUTPUT())))
					m.nSBUpRow = INT(ROUND(m.nSBVRange * (m.nSBUpRow - SYSMETRIC(15)) / (m.nSBBottom - m.nSBTop - 2 * SYSMETRIC(15)), 0))
					= SBMOVEWIN(SBGETPOS(SB_VERT) - m.nSBUpRow, 0)
				ENDIF

			CASE m.nMRow < m.nSBThumbPos	&& Page Up
				IF SBGETPOS(SB_VERT) > 0
					= SBMOVEWIN(_WHEIGHTP(m.hSBWinScroll) - FONTMETRIC(1), 0)
				ENDIF

			CASE m.nMRow > m.nSBThumbPos	&& Page Down
				IF SBGETPOS(SB_VERT) < _WHEIGHTP(m.hSBWinChild)
					= SBMOVEWIN(-_WHEIGHTP(m.hSBWinScroll) + FONTMETRIC(1), 0)
				ENDIF

		ENDCASE

	CASE m.nHitTest = HTHSCROLL ;
			AND m.nMRow < _WBOTTOMP(m.hSBWinScroll)	;
			+ SYSMETRIC(9) + SYSMETRIC(20)	;
			AND m.nMCol > _WLEFTP(m.hSBWinScroll) && Hit Horizontal Scroll Bar
		*
		* Call DefFrameProc with Parameters to say User
		* clicked Left Mouse Button.  This will cause scroll bar
		* to respond to mouse click
		*
		= CALLFN(m.hSBDefFrame, _WHTOHWND(m.hSBWinScroll), m.hWSBWinFox, WM_NCLBUTTONDOWN, m.nHitTest, m.nMPos)

		*
		* Save mouse position when user let up mouse button
		*
		m.nMUpRow = MROW("")
		m.nMUpCol = MCOL("")
		m.nSBUpRow = MROW(WPARENT(WOUTPUT()))
		m.nSBUpCol = MCOL(WPARENT(WOUTPUT()))

		*
		* Determine where on scroll bar user clicked and take
		* appropriate action
		*
		m.nSBTop = _WLEFTP(m.hSBWinScroll) + IIF(WBORDER(WPARENT(WOUTPUT())),SYSMETRIC(3)/2,-SYSMETRIC(10))
		m.nSBBottom = m.nSBTop + _WWIDTHP(m.hSBWinScroll) + IIF(WBORDER(WPARENT(WOUTPUT())),SYSMETRIC(3),4*SYSMETRIC(10))
		m.nSBThumbPos = m.nSBTop + SYSMETRIC(7) + SBGETPOS(SB_HORZ)/m.nSBHRange * (m.nSBBottom - m.nSBTop - 2 * SYSMETRIC(7) - SYSMETRIC(14))
		DO CASE
			CASE BETWEEN(m.nMCol, m.nSBTop, m.nSBTop+SYSMETRIC(7)) && Left Arrow
				IF SBGETPOS(SB_HORZ) > 0
					= SBMOVEWIN(0, FONTMETRIC(6))
				ENDIF

			CASE BETWEEN(m.nMCol, m.nSBBottom-SYSMETRIC(7), m.nSBBottom) && Right Arrow
				IF SBGETPOS(SB_HORZ) < _WHEIGHTP(m.hSBWinChild)
					= SBMOVEWIN(0, -FONTMETRIC(6))
				ENDIF

			CASE BETWEEN(m.nMCol, m.nSBThumbPos, m.nSBThumbPos + SYSMETRIC(14)) && Thumb
				m.nMUpRow = m.nMUpRow * FONTMETRIC(1,WFONT(1,""), WFONT(2,""), WFONT(3,"")) + SYSMETRIC(9) + SYSMETRIC(20)
				m.nMUpCol = m.nMUpCol * FONTMETRIC(6,WFONT(1,""), WFONT(2,""), WFONT(3,""))
				m.nMPos = INT(m.nMUpRow * 2^16 + m.nMUpCol)
				m.nHitTest = CALLFN(m.hSBDefFrame, _WHTOHWND(m.hSBWinScroll), m.hWSBWinFox, WM_NCHITTEST, 0, m.nMPos)
				IF m.nHitTest = HTHSCROLL ;
						AND m.nMUpRow < _WBOTTOMP(m.hSBWinScroll) + SYSMETRIC(9) + SYSMETRIC(20) ;
						AND m.nMUpCol > _WLEFTP(m.hSBWinScroll)	&& Still on Scroll Bar
					m.nSBUpCol = m.nSBUpCol * FONTMETRIC(6,WFONT(1,WPARENT(WOUTPUT())), WFONT(2,WPARENT(WOUTPUT())), WFONT(3,WPARENT(WOUTPUT())))
					m.nSBUpCol = INT(ROUND(m.nSBHRange * (m.nSBUpCol - SYSMETRIC(14)) / (m.nSBBottom - m.nSBTop - 2 * SYSMETRIC(14)), 0))
					= SBMOVEWIN(0, SBGETPOS(SB_HORZ) - m.nSBUpCol)
				ENDIF

			CASE m.nMCol < m.nSBThumbPos	&& Page Left
				IF SBGETPOS(SB_HORZ) > 0
					= SBMOVEWIN(0, _WWIDTHP(m.hSBWinScroll) - FONTMETRIC(6))
				ENDIF

			CASE m.nMCol > m.nSBThumbPos	&& Page Right
				IF SBGETPOS(SB_HORZ) < _WWIDTHP(m.hSBWinChild)
					= SBMOVEWIN(0, -_WWIDTHP(m.hSBWinScroll) + FONTMETRIC(6))
				ENDIF

		ENDCASE

ENDCASE

SET DECIMALS TO (m.nDec)
POP KEY
RETURN


*****************
FUNCTION SBGETPOS
*****************
**
** Function gets the scroll bar
** thumbtack position and returns
** the number.
**
** PARAMETER:	nWhichBar - Verticle or Horizontal
**				scroll bar indicator.
**
PARAMETER nWhichBar
RETURN CALLFN(m.hSBGetPos, _WHTOHWND(m.hSBWinScroll), m.nWhichBar)

*****************
FUNCTION SBSETPOS
*****************
**
** Function sets the scroll bar
** thumbtack position based on the
** position of the child window in
** the parent window.
**
** PARAMETER:	nWhichBar - Verticle or Horizontal scroll bar indicator.
**				nSBNewPos - New Position Value
**
PARAMETER nWhichBar, nSBNewPos
PRIVATE nSBOldPos
IF m.nWhichBar = SB_VERT
	m.nSBOldPos = CALLFN(m.hSBSetPos, _WHTOHWND(m.hSBWinScroll), SB_VERT, m.nSBNewPos, TRUE)
ENDIF
IF m.nWhichBar = SB_HORZ
	m.nSBOldPos = CALLFN(m.hSBSetPos, _WHTOHWND(m.hSBWinScroll), SB_HORZ, m.nSBNewPos, TRUE)
ENDIF
RETURN m.nSBOldPos


******************
FUNCTION SBMOVEWIN
******************
**
** Function sets the child window postion
** within the parent window.
**
** PARAMETER:	nRow - Move by Row amount
**				nCol - Move by Column amount
**
PARAMETER nRow, nCol
IF m.nRow # 0
	= SBSETPOS(SB_VERT, SBGETPOS(SB_VERT) - m.nRow)
ENDIF
IF m.nCol # 0
	= SBSETPOS(SB_HORZ, SBGETPOS(SB_HORZ) - m.nCol)
ENDIF
= _WMOVEP(m.hSBWinChild, -SBGETPOS(SB_HORZ), -SBGETPOS(SB_VERT))
RETURN

*****************
FUNCTION SBPAGEUP
*****************
**
** Function called by ON KEY LABEL PGUP
**
PUSH KEY CLEAR
IF SBGETPOS(SB_VERT) > 0
	= SBMOVEWIN(_WHEIGHTP(m.hSBWinScroll) - FONTMETRIC(1), 0)
ENDIF
POP KEY

*****************
FUNCTION SBPAGEDN
*****************
**
** Function called by ON KEY LABEL PGDN
**
PUSH KEY CLEAR
IF SBGETPOS(SB_VERT) < _WHEIGHTP(m.hSBWinChild)
	= SBMOVEWIN(-_WHEIGHTP(m.hSBWinScroll) + FONTMETRIC(1), 0)
ENDIF
POP KEY
*: EOF: SCROLL.PRG
